/**
 * Created by IntelliJ IDEA.
 * User: dlyon
 * Date: Nov 12, 2003
 * Time: 1:32:09 PM
 * To change this template use Options | File Templates.
 */
package centij;

import classUtils.dumper.ByteCodeContainer;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import futils.Futil;
import futils.Ls;
import classUtils.dumper.*;

public class Cr320Midterm {
    public static void dumpAClassFile() {
        FileInputStream fis = Futil.getFileInputStream("Select a class file");
        getComputableObjectImplementor(fis);

    }

    public static void dumpClassFile(File f[]) {
        for (int i = 0; i < f.length; i++)
            dumpClassFile(f[i]);
    }

    public static void dumpClassFile(File f) {
        try {
            FileInputStream fis = new FileInputStream(f);
            Class c = getComputableObjectImplementor(fis);
            if (c != null)
                System.out.println("This class is a ComputableObject" +
                        c.getName());
            fis.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static Class getComputableObjectImplementor(FileInputStream fis) {
        ByteCodeContainer bcc = classUtils.dumper.ByteCodeContainer.getByteCodeContainer(
                fis);
        bcc.loadIt();
        Class c = bcc.getClass();
        Class interfaces[] = c.getInterfaces();
        for (int i = 0; i < interfaces.length; i++)
            if (interfaces[i].getName().endsWith("ComputableObject"))
                return c;
        return null;
    }

    public static void dumpAllFilesInADirectory() {
        File f[] = Ls.getWildFiles(
                Futil.getReadDirFile(
                        "select a class directory"), "class");
        dumpClassFile(f);

    }

    public static void main(String args[]) {
        dumpAllFilesInADirectory();
    }
}
