package net.rmi.utils;

import classUtils.putils.ClassPathUtils;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

import gui.In;

public class Compile {
    public static void rmic() {
        String
                fn = "rmi.rmiimage.Server";
        rmic(fn);
    }

    public static void startWebStart() {
        String args[] = {
            "C:\\Program Files\\Java Web Start\\javaws.exe",
            "http://show.docjava.com:8086/book/cgij/code/jnlp/dhry.Main.jnlp"
        };
        try {
            Runtime rt = Runtime.getRuntime();
            Process p = rt.exec(args, null, new File("c:\\lyon\\j4p\\classes"));
            BufferedReader br
                    = new BufferedReader(new InputStreamReader(p.getErrorStream()));
            String s = null;
            while ((s = br.readLine()) != null)
                System.out.println("dos:" + s);
            boolean kill = In.promptYesNo("kill the dhrystone?");
            p.destroy();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String args[]) {
        //rmicTestDos2();
        startWebStart();
    }

    private static void rmicTestDos() {
        Runtime rt = Runtime.getRuntime();
        String args1[] = {
            "C:\\j2sdk1.4.1_02\\bin\\rmic",
            "-v1.2 -classpath", "c:\\lyon\\j4p\\classes",
            "d", "c:\\lyon\\j4p\\classes",
            "net.rmi.armi.RemoteHelloImplementation"
        };
        String args[] = {
            "dir"
        };
        try {
            Process p = rt.exec(args, null, new File("c:\\lyon\\j4p\\classes"));
            BufferedReader br
                    = new BufferedReader(new InputStreamReader(p.getErrorStream()));
            String s = null;
            while ((s = br.readLine()) != null)
                System.out.println("dos:" + s);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static void rmicTestDos2() {   // fails!
        Runtime rt = Runtime.getRuntime();
        String args[] = {
            "C:\\j2sdk1.4.1_02\\bin\\rmic",
            "-v1.2",
            "-classpath", "c:\\lyon\\j4p\\classes\\",
            "d", "c:\\lyon\\j4p\\classes\\net\\rmi\\armi\\",
            "net.rmi.armi.RemoteHelloImplementation"
        };
        try {
            Process p = rt.exec(args, null, new File("c:\\lyon\\j4p\\classes"));
            BufferedReader br
                    = new BufferedReader(new InputStreamReader(p.getErrorStream()));
            String s = null;
            while ((s = br.readLine()) != null)
                System.out.println("dos:" + s);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void rmicTester() {
        String version = "-v1.2";
        String classpath = "c:\\lyon\\j4p\\classes";
        String destination = "c:\\lyon\\j4p\\classes";
        Class clazz = net.rmi.armi.RemoteHelloImplementation.class;
        rmic(version, classpath, destination, clazz);
    }

    public static void rmic(String version,
                            String classpath,
                            String destination,
                            Class clazz) {
        String args[] = {
            version,
            "-classpath", classpath,
            "-d", destination,
            clazz.getName()
        };
        rmic(args);
    }

    public static void rmic(String[] args) {
        sun.rmi.rmic.Main.main(args);
    }

    public static void armic() {
        String cp = ClassPathUtils.getClassPathInUserDir();
        String[] strings = {
            "-v1.2",
            " -d",
            cp,
            "net.rmi.armi.RemoteHelloImplementation"};
        rmic(strings);
    }

    static public void rmic(Class c) {
        String cn = c.getName();
        String cp = ClassPathUtils.getClassPathInUserDir();
        String args[] = {
            "-v1.2", " -d", "C:\\lyon\\j4p\\classes", "net.rmi.armi.RemoteHelloImplementation"
        };
        sun.rmi.rmic.Main.main(args);
    }

    static public void rmic(String fn) {
        String args[] = {fn};
        rmic(args);
    }
}